/*
 * ISIS interface from Fortran
 */
 
#include "isis.h"

#ifdef  GOULD
# undef gould           /* Correct bizarre problem with va_arg on struct passed by value */
#endif
#include <varargs.h>

abcast_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_ABCAST, 0, "", &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

abcastl_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_ABCAST, CL_ABCAST_EX, va_arg(ap, char *), &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

bcast_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_ABCAST, 0, "", &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

bcastl_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_ABCAST, CL_ABCAST_EX, va_arg(ap, char *), &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

abortreply_(mp)
  message **mp;
  {
	return abortreply(*mp);
  }

addrcmp_(a, b)
  address *a, *b;
  {
        return addr_cmp(*a, *b);
  }

addrismine_(a)
  address *a;
  {
        return addr_ismine(*a);
  }

addrisnull_(a)
  address *a;
  {
        return addr_isnull(*a);
  }

addrprocess_(a)
  address *a;
  {
        return a->process;
  }

addrentry_(a)
  address *a;
  {
        return a->entry;
  }

addrsite_(a)
  address *a;
  {
        return a->site;
  }

addrincarn_(a)
  address *a;
  {
        return a->incarn;
  }

alistlen_(alist)
  address *alist;
  {
        return alist_len(alist);
  }

bccancel_(bcid)
  int *bcid;
  {
        return bc_cancel(*bcid);
  }

bcgetevent_(eid, bcid)
  event_id *eid;
  int *bcid;
  {
        *eid = bc_getevent(*bcid);
  }

bcpoll_(bcid)
  int *bcid;
  {
        return bc_poll(*bcid);
  }

bcwait_(bcid)
  int *bcid;
  {
        return bc_wait(*bcid);
  }

cbcast_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_CBCAST, 0, "", &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

cbcastl_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_CBCAST, CL_CBCAST_EX, va_arg(ap, char *), &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

ccterminate_(va_alist)
  va_dcl
  {
        va_list ap;
        va_start(ap);
        BEGINFROMFORTRAN
            do_ccterminate(&ap);
        ENDFROMFORTRAN
        va_end(ap);
  }

static char *imsg = "**** subroutine/function parameter was not declared external";
#define is_ifunc(routine) { if(((char**)routine) && *((char**)routine) == (char*)0) panic(imsg); }

coordcohort_(mp, gaddr, action, gotresult, arg)
  message **mp;
  address *gaddr;
  ifunc *action, *gotresult;
  int *arg;
  {
        is_ifunc(action);
        is_ifunc(gotresult);
        return coord_cohort(*mp, *gaddr, action, gotresult, *arg);
  }

eidsender_(eid)
  event_id *eid;
  {
        return eid_sender(*eid);
  }

cbflush_()
  {
        return flush();
  }

forward_(fmsg, to, ent, cmsg)
  message **fmsg, **cmsg;
  address *to;
  int *ent;
  {
        return forward(*fmsg, *to, *ent, *cmsg);
  }

fbcast_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_FBCAST, 0, "", &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

fbcastl_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_FBCAST, CL_FBCAST_EX, va_arg(ap, char *), &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

gbcast_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_GBCAST, 0, "", &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

gbcastl_(va_alist)
  va_dcl
  {
        int rval;
        va_list ap;
        va_start(ap);
	BEGINFROMFORTRAN
            rval = do_bcast(CL_GBCAST, CL_GBCAST_EX, va_arg(ap, char *), &ap);
	ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

guard_()
  {
        panic("guard() not supported from fortran");
  }

isissetfilter_(proc)
  ifunc *proc;
  {
        is_ifunc(proc);
        return (int)isis_setfilter(proc);
  }

isisacceptevents_()
  {
        return isis_accept_events();
  }

isisdefinetype_(typeno, formatletter, size, converter)
  int *typeno, *formatletter, *size;
  ifunc *converter;
  {
        is_ifunc(converter);
        return isis_define_type(*typeno, *formatletter, *size, converter);
  }

isisdisconnect_()
  {
        return isis_disconnect();
  }

isisentry_(entry, routine, rname)
  int *entry;
  ifunc *routine;
  char *rname;
  {
        register rv;
	is_ifunc(routine);
	BEGINFROMFORTRAN;
            rv = isis_entry(*entry, routine, rname);
	ENDFROMFORTRAN;
        return rv;
  }

isisentrystacksize_(entry, size)
  int *entry, *size;
  {
        return isis_entry_stacksize(*entry, *size);
  }

isisinit_(CLIENTPORT)
  int *CLIENTPORT;
  {
        return isis_init(*CLIENTPORT);
  }

isisinput_(fdes, handler, arg)
  int *fdes, *arg;
  ifunc *handler;
  {
	is_ifunc(handler);
        return isis_input(*fdes, handler, *arg);
  }

isisinputdrain_()
  {
        return isis_input_drain();
  }

isisinputsig_(fdes, cond, arg)
  int *fdes, *cond, *arg;
  {
        return isis_input_sig(*fdes, cond, *arg);
  }

isislogging_(flag)
  int *flag;
  {
        return isis_logging(*flag);
  }

isismainloop_(routine)
 ifunc *routine;
  {
        return isis_mainloop(routine);
  }

isisperror_(str)
  char *str;
  {
        return isis_perror(str);
  }

isisrexec_(nwanted, gid, sites, prog, args, env, user, passwd, addrs)
  int *nwanted;
  address *gid, *addrs;
  site_id *sites;
  char *prog, **args, **env, *user, *passwd;
  {
        return isis_rexec(*nwanted, *gid, sites, prog, args, env, user, passwd, addrs);
  }

isissignal_(signo, handler, arg)
  int *signo, *arg;
  ifunc *handler;
  {
	is_ifunc(handler);
        return isis_signal(*signo, handler, *arg);
  }

isissleep_(n)
  int *n;
  {
        return isis_sleep(*n);
  }

isissleepms_(ms)
  int *ms;
  {
        return isis_sleep_ms(*ms);
  }

isisstartdone_()
  {
        return isis_start_done();
  }

isistask_(routine, rname)
  ifunc *routine;
  char *rname;
  {
	is_ifunc(routine);
        return isis_task(routine, rname);
  }

isistimeout_(time, routine, arg0, arg1)
  int *time, *arg0, *arg1;
  ifunc *routine;
  {
	is_ifunc(routine);
        return isis_timeout(*time, routine, *arg0, *arg1);
  }

isistimeoutreschedule_(oldtid, time, routine, arg0, arg1)
  int *oldtid, *time, *arg0, *arg1;
  ifunc *routine;
  {
	is_ifunc(routine);
        return isis_timeout_reschedule(*oldtid, *time, routine, *arg0, *arg1);
  }

isislogentry_(gaddr, entry)
  address *gaddr;
  int *entry;
  {
        return isis_logentry(*gaddr, *entry);
  }

logcheckpoint_(gname)
  char *gname;
  {
        return log_checkpoint(gname);
  }

logflush_(gaddr)
  address *gaddr;
  {
        return log_flush(*gaddr);
  }

loghasckpt_(gname)
  char *gname;
  {
        return log_has_ckpt(gname);
  }

logrecovered_(gaddr)
  address *gaddr;
  {
        return log_recovered(*gaddr);
  }

logwrite_(gaddr, mp)
  address *gaddr;
  message **mp;
  {
        return log_write(*gaddr, mp);
  }

msgdelete_(mp)
  message **mp;
  {
        return msg_delete (*mp);
  }

msgread_(sock)
  int *sock;
  {
        return (int)msg_read(*sock);
  }

msgwrite_(sock, mp)
  int *sock;
  message **mp;
  {
        return msg_write(*sock, *mp);
  }

msgfread_(file)
  FILE *file;
  {
        return (int)msg_fread(file);
  }

msgfwrite_(file, mp)
  FILE *file;
  message **mp;
  {
        return msg_fwrite(file, *mp);
  }

msggen_(va_alist)
  va_dcl
  {
        va_list ap;
        register message *mp;
        register rval;
	ISIS_ENTER();
        mp = msg_newmsg();
        va_start(ap);
        BEGINFROMFORTRAN
            rval = msg_doputf(mp, SYSFLD_SCAN, &ap);
        ENDFROMFORTRAN
        va_end(ap);
        if(rval == 0)
            ISIS_RETURN((int)mp);
        msg_delete(mp);
        ISIS_RETURN(0);
  }

msgget_(va_alist)
  va_dcl
  {
        va_list ap;
        message *mp;
        int rval;
        va_start(ap);
	mp = *va_arg(ap, message**);
        BEGINFROMFORTRAN
            rval = msg_dogetf(&mp, 1, SYSFLD_SCAN, &mp->fpointer, &ap);
        ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

msggetfld_(va_alist)
  va_dcl
  {
        int one = 1;
        va_list ap;
        message *mp;
        register fname, *fpointer, rval;
        va_start(ap);
	mp = *va_arg(ap, message**);
	fname = *va_arg(ap, int*);
        fpointer = va_arg(ap, int*);
        if(fpointer && *fpointer == 0)
            fpointer = &one;
        BEGINFROMFORTRAN
            rval = msg_dogetf(&mp, 1, fname, fpointer, &ap);
        ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

msgdests_(dlist, mp)
  address *dlist;
  message **mp;
  {
        register address *dl = msg_getdests (*mp);
        bcopy(dl, dlist, (alist_len(dl)+1) * sizeof(address));
  }

msgreplyto_(addr, mp)
  address *addr;
  message **mp;
  {
        *addr = msg_getreplyto (*mp);
  }

msgsender_(addr, mp)
  address *addr;
  message **mp;
  {
        *addr = msg_getsender (*mp);
  }

msgtruesender_(addr, mp)
  address *addr;
  message **mp;
  {
        *addr = msg_gettruesender (*mp);
  }

msggettype_(mp, field, inst)
  message **mp;
  int *field, *inst;
  {
        return msg_gettype(*mp, *field, *inst);
  }

msgincrefcount_(mp)
  message **mp;
  {
        return msg_increfcount (*mp);
  }

msgismsg_(mp)
  message **mp;
  {
        return msg_ismsg (*mp);
  }

msgmakelazy_(mp, howlazy)
  message **mp;
  int *howlazy;
  {
        return msg_makelazy (*mp, *howlazy);
  }

msgnewmsg_()
  {
        return (int)msg_newmsg ();
  }

msgput_(va_alist)
  va_dcl
  {
        va_list ap;
        message *mp;
        register rval;
        va_start(ap);
        mp = *va_arg(ap, message**);
        BEGINFROMFORTRAN
            rval = msg_doputf(mp, SYSFLD_SCAN, &ap);
        ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

msgputfld_(va_alist)
  va_dcl
  {
        va_list ap;
        register char *fmt;
        message *mp;
        register rval, fname;
        va_start(ap);
        mp = *va_arg(ap, message**);
        fname = *va_arg(ap, int*);
        BEGINFROMFORTRAN
            rval = msg_doputf(mp, fname, &ap);
        ENDFROMFORTRAN
        va_end(ap);
        return rval;
  }

msgrewind_(mp)
  message **mp;
  {
        return msg_rewind(*mp);
  }

isisread_()
  {
	return isis_read();
  }

newsapost_(slist, subj, mp, back)
  site_id *slist;
  char *subj;
  message **mp;
  int *back;
  {
        news_apost(slist, subj, *mp, *back);
  }

newscancel_(subj)
  char *subj;
  {
        news_cancel(subj);
  }

newsclear_(slist, subj)
  site_id  slist[];
  char     *subj;
  {
        news_clear(slist, *subj);
  }

newsclearall_(slist, subj)
  site_id  slist[];
  char     *subj;
  {
        news_clear_all(slist, *subj);
  }

newspost_(slist, subj, mp, back)
  site_id *slist;
  char *subj;
  message **mp;
  int *back;
  {
        news_post(slist, subj, *mp, *back);
  }

newssubscribe_(subj, entry, back)
  char *subj;
  int *entry, *back;
  {
        return news_subscribe(subj, *entry, *back);
  }

nullreply_(mp)
  message **mp;
  {
        return nullreply(*mp);
  }

paddr_(addr)
  address *addr;
  {
        return paddr(*addr);
  }

paddrs_(addr)
  address *addr;
  {
        return paddrs(addr);
  }

peid_(eid)
  event_id *eid;
  {
        return peid(*eid);
  }

pentry_(addr, entry)
  address *addr;
  int *entry;
  {
        return pentry(*addr, *entry);
  }

pgclient_(gaddr, credentials)
  address *gaddr;
  char *credentials;
  {
        return pg_client(*gaddr, credentials);
  }

pgclientverifier_(gname, routine)
  char *gname;
  ifunc *routine;
  {
	is_ifunc(routine);
        return pg_client_verifier(gname, routine);
  }

pgdelete_(gaddr)
  address *gaddr;
  {
        return pg_delete(*gaddr);
  }

pggetlocalview_(gaddr)
  address *gaddr;
  {
        return (int)pg_getlocalview(*gaddr);
  }

pggetview_(gaddr)
  address *gaddr;
  {
        return (int)pg_getview(*gaddr);
  }

pgjoin_(va_alist)
  va_dcl
  {
        address *addr, pg_dojoin();
	va_list ap;
        va_start(ap); 
        addr = va_arg(ap, address*);
        BEGINFROMFORTRAN
            *addr = pg_dojoin(&ap); 
        ENDFROMFORTRAN
        va_end(ap); 
  }

xferout_(va_alist)
  va_dcl
  {
        int locator;
        va_list ap;
        message *mp;
        va_start(ap);
        locator = *va_arg(ap, int*);
	ISIS_ENTER();
        mp = msg_newmsg();
        BEGINFROMFORTRAN
            msg_doputf(mp, SYSFLD_SCAN, &ap);
        ENDFROMFORTRAN
        do_xfer_out(locator, mp);
	va_end(ap);
        msg_delete(mp);
	ISIS_EXIT();
  }

xferflush_()
  {
	xfer_flush();
  }

pgjoininhibit_(flag)
  int *flag;
  {
        return pg_join_inhibit(*flag);
  }

pgleave_(gaddr)
  address *gaddr;
  {
        return pg_leave(*gaddr);
  }

pglookup_(addr, gname)
  char *gname;
  address *addr;
  {
        *addr =  pg_lookup(gname);
  }

pgmonitor_(gaddr, routine, arg)
  address *gaddr;
  ifunc *routine;
  int *arg;
  {
        int rval;
	is_ifunc(routine);
        BEGINFROMFORTRAN
            rval = pg_monitor(*gaddr, routine, *arg);
        ENDFROMFORTRAN
        return rval;
  }

pgmonitorcancel_(pwid)
  int *pwid;
  {
        return pg_monitor_cancel(*pwid);
  }

pgrank_(gaddr, who)
  address *gaddr, *who;
  {
        return pg_rank(*gaddr, *who);
  }

pgrankall_(gaddr, who)
  address *gaddr, *who;
  {
        return pg_rank_all(*gaddr, *who);
  }

pgsignal_(gaddr, signo)
  address *gaddr;
  int *signo;
  {
        return pg_signal(*gaddr, *signo);
  }

pgsubgroup_(sgaddr, gaddr, sgname, incarn, mlist, clist)
  address *sgaddr, *gaddr, *mlist, *clist;
  char *sgname;
  int *incarn;
  {
        address pg_subgroup();
        *sgaddr = pg_subgroup(*gaddr, sgname, *incarn, mlist, clist);
  }

pgwatch_(gaddr, who, event, routine, arg)
  address *gaddr, *who;
  int *event, *arg;
  ifunc *routine;
  {
        int rval;
	is_ifunc(routine);
        BEGINFROMFORTRAN
            rval = pg_watch(*gaddr, *who, *event, routine, *arg);
        ENDFROMFORTRAN
        return rval;
  }

pgwatchcancel_(wid)
  int *wid;
  {
        return pg_watch_cancel(*wid);
  }

pmsg_(mp)
  message **mp;
  {
        return pmsg(*mp);
  }

procwatch_(paddr, routine, arg)
  address *paddr;
  ifunc *routine;
  int *arg;
  {
        int rval;
	is_ifunc(routine);
        BEGINFROMFORTRAN
            rval = proc_watch(*paddr, routine, *arg);
        ENDFROMFORTRAN
        return rval;
  }

procwatchcancel_(wid)
  int *wid;
  {
        return proc_watch_cancel(*wid);
  }

psid_(sid)
  site_id *sid;
  {
        return psid(*sid);
  }

reply_(va_alist)
  va_dcl
  {
        va_list ap;
        va_start(ap);
        BEGINFROMFORTRAN
            do_reply(&ap);
        ENDFROMFORTRAN
        va_end(ap);
  }

replyl_(va_alist)
  va_dcl
  {
        va_list ap;
        va_start(ap);
        BEGINFROMFORTRAN
            do_reply_l(&ap);
        ENDFROMFORTRAN
        va_end(ap);
  }

rmgrcreate_(addr, rmi)
  address *addr;
  rmgr_info *rmi;
  {
        *addr = rmgr_create(rmi);
  }

rmgrgetinfo_(rmi, pgname, noblock)
  rmgr_info *rmi;
  char *pgname;
  int *noblock;
  {
        rmgr_info *rmgr_getinfo();
        *rmi = *rmgr_getinfo(pgname, *noblock);
  }

rmgrjoin_(addr, rmi)
  address *addr;
  rmgr_info *rmi;
  {
        *addr = rmgr_join(rmi);
  }

rmgrlasttofail_(gname, key, oldincarnp, noblock)
  char  *gname, *key;
  int   *oldincarnp, *noblock;
  {
        return rmgr_lasttofail(gname, key, oldincarnp, *noblock);
  }

rmgrregister_(key)
  char *key;
  {
        return rmgr_register(key);
  }

rmgrrestart_(addr, pgname)
  address *addr;
  char *pgname;
  {
        *addr = rmgr_restart(pgname);
  }

rmgrstartlog_(gad, key)
  address *gad;
  char *key;
  {
        return rmgr_start_log(*gad, key);
  }

rmgrstoplog_(gad, key)
  address *gad;
  char *key;
  {
        return rmgr_stop_log(*gad, key);
  }

rmgrunregister_()
  {
        return rmgr_unregister();
  }

rmgrupdate_(key, program, argv, envp)
  char *key, *program, **argv, **envp;
  {
        return rmgr_update(key, program, argv, envp);
  }

runtasks_()
  {
        return run_tasks();
  }

sitegetview_()
  {
        return (int)site_getview();
  }

svviewid_(sv)
  sview **sv;
  {
	return (*sv)->sv_viewid;
  }

svslist_(sv, i)
  sview **sv;
  int *i;
  {
        return (*sv)->sv_slist[*i];
  }

svincarn_(sv, i)
  sview **sv;
  int *i;
  {
        return (int)(*sv)->sv_incarn[*i];
  }

svfailed_(bv, sv)
  bitvec *bv;
  sview **sv;
  {
        *bv = (*sv)->sv_failed;
  }

svrecovered_(bv, sv)
  bitvec *bv;
  sview **sv;
  {
        *bv = (*sv)->sv_recovered;
  }

bit_(bv, i)
  bitvec *bv;
  int *i;
  {
        return bit(*bv, *i);
  }

bis_(bv, i)
  bitvec *bv;
  int *i;
  {
        return bis(*bv, *i);
  }

bclr_(bv)
  bitvec *bv;
  {
        bclr(*bv);
  }

btst_(bv)
  bitvec *bv;
  {
        return btst(*bv);
  }

bzero_(bv)
  bitvec *bv;
  {
        bzero(*bv);
  }
  
svmonitor_(routine, arg)
  ifunc *routine;
  int *arg;
  {
        int rval;
	is_ifunc(routine);
        BEGINFROMFORTRAN
            rval = sv_monitor(routine, *arg);
        ENDFROMFORTRAN
        return rval;
  }

svmonitorcancel_(svid)
  int *svid;
  {
        return sv_monitor_cancel(*svid);
  }

svwatch_(sid, event, routine, arg)
  site_id *sid;
  ifunc *routine;
  int *event, *arg;
  {
        int rval;
	is_ifunc(routine);
        BEGINFROMFORTRAN
            rval = sv_watch(*sid, *event, routine, *arg);
        ENDFROMFORTRAN
        return rval;
  }

svwatchcancel_(svid)
  int *svid;
  {
        return sv_watch_cancel(*svid);
  }

tholder_(who, gaddr, name)
  address *who, *gaddr;
  char *name;
  {
	address t_holder();
        *who = t_holder(*gaddr, name);
  }

tonsysstack_(routine, arg)
  ifunc *routine;
  int *arg;
  {
	is_ifunc(routine);
        return t_on_sys_stack(routine, *arg);
  }

tpass_(gaddr, name)
  address *gaddr;
  char *name;
  {
        return t_pass(*gaddr, name);
  }

trequest_(gaddr, name, passonfail)
  address *gaddr;
  char *name;
  int *passonfail;
  {
        return t_request(*gaddr, name, *passonfail);
  }

tscheck_()
  {
        return t_scheck();
  }

tfork_(routine, arg)
  ifunc *routine;
  char **arg;
  {
	BEGINFROMFORTRAN;
            t_fork(routine, *arg);
        ENDFROMFORTRAN;
  }

tsig_(cp, rval)
  condition *cp;
  int *rval;
  {
        return t_sig(cp, *rval);
  }

tsigall_(cp, rval)
  condition *cp;
  int *rval;
  {
        return t_sig_all(cp, *rval);
  }

tsigurgent_(cp, rval)
  condition *cp;
  int *rval;
  {
        return t_sig_urgent(cp, *rval);
  }

tsuspend_()
  {
        return t_suspend();
  }

twait_(cp)
  condition *cp;
  {
        return t_wait(cp);
  }

twaitl_(cp, why)
  condition *cp;
  char *why;
  {
        return t_wait_l(cp, why);
  }

xabort_()
  {
        return x_abort();
  }

xbegin_()
  {
        return x_begin();
  }

xcommit_(phases)
  int *phases;
  {
        return x_commit(*phases);
  }

xgetid_(xid)
  x_id *xid;
  {
        x_id x_getid();
        *xid = x_getid();
  }

xidcmp_(id1, id2)
  x_id *id1, *id2;
  {
	return xid_cmp(*id1, *id2);
  }

xoutcomes_(xlist, partname)
  x_list *xlist;
  char *partname;
  {
        x_list *x_outcomes(), *xlp;
        xlp = x_outcomes(partname);
        bcopy(xlp, xlist, &((x_list*)0)->items[xlp->len]);
  }

xoutcomesflush_(partname, outcomes)
  char *partname;
  x_list *outcomes;
  {
        x_outcomes_flush(partname, outcomes);
  }

xterm_(va_alist)
  va_dcl
  {
	char *participant_name;
	ifunc *on_prepare;
	ifunc *on_commit;
	ifunc *on_abort;
        int rval;
	message *data = msg_newmsg();
	va_list vargs;

	va_start(vargs);
	participant_name = va_arg(vargs, char *);
	on_prepare = va_arg(vargs, ifunc *);
	on_commit = va_arg(vargs, ifunc *);
	on_abort = va_arg(vargs, ifunc *);
        BEGINFROMFORTRAN
	    rval = msg_doputf(data, SYSFLD_SCAN, &vargs);
	ENDFROMFORTRAN
	va_end(vargs);
	if(rval)
        {
            msg_delete(data);
            return(-1);
        }
	return x_doterm(participant_name, on_prepare, on_commit, on_abort, data);
  }

mysno_()
  {
        return my_site_no;
  }

mysincarn_()
  {
        return my_site_incarn;
  }

mysid_()
  {
        return my_site_id;
  }

mypid_()
  {
        return my_process_id;
  }

myaddress_(addr)
  address *addr;
  {
        *addr = my_address;
  }

myhost_(where)
  char *where;
  {
        strcpy(where, my_host);
  }

sitenames_(where, i)
  char *where;
  int *i;
  {
        strcpy(where, site_names[*i]);
  }

address_(addr, site, inc, pro, ent)
  address *addr;
  int *site, *inc, *pro, *ent;
  {
        *addr = ADDRESS(site, inc, pro, ent);
  }

nulladdress_(addr)
  address *addr;
  {
        *addr = NULLADDRESS;
  }

isiserrno_()
  {
        return isis_errno;
  }

isisdir_(where)
  char *where;
  {
        strcpy(where, isis_dir);
  }

isisnsent_()
  {
        return isis_nsent;
  }

isisnreplies_()
  {
        return isis_nreplies;
  }

isissocket_()
  {
        return isis_socket;
  }

isisstate_()
  {
        return isis_state;
  }

gvviewid_(gv)
  register groupview **gv;
  {
        return (*gv)->gv_viewid;
  }

gvincarn_(gv)
  register groupview **gv;
  {
        return (*gv)->gv_incarn;
  }

gvflag_(gv)
  register groupview **gv;
  {
        return (*gv)->gv_flag;
  }

gvgaddr_(addr, gv)
  register address *addr;
  register groupview **gv;
  {
        *addr =  (*gv)->gv_gaddr;
  }

gvname_(str, gv)
  register groupview **gv;
  register char *str;
  {
        strcpy(str, (*gv)->gv_name);
  }

gvnmemb_(gv)
  register groupview **gv;
  {
        return (*gv)->gv_nmemb;
  }

gvnclient_(gv)
  register groupview **gv;
  {
        return (*gv)->gv_nclient;
  }

gvmember_(addr, gv, n)
  register address *addr;
  register int *n;
  register groupview **gv;
  {
        *addr = (*gv)->gv_members[*n];
  }

gvclient_(addr, gv, n)
  register address *addr;
  register int *n;
  register groupview **gv;
  {
        *addr = (*gv)->gv_clients[*n];
  }

gvjoined_(addr, gv)
  register address *addr;
  register groupview **gv;
  {
        *addr = (*gv)->gv_joined;
  }

gvdeparted_(addr, gv)
  register address *addr;
  register groupview **gv;
  {
        *addr = (*gv)->gv_departed;
  }

pmembers_(gv)
  register groupview **gv;
  {
	paddrs((*gv)->gv_members);
  }

pclients_(gv)
  register groupview **gv;
  {
	paddrs((*gv)->gv_clients);
  }
